/* Make a button like a navbar item. */

html {
    --hackreactor-dark-blue: #0D0F4A;
    --hackreactor-light-blue: #3F64DD;
}

button.navbar-item {
    background-color: transparent;
    border: 0;
    border-radius: 0;
    flex: 1 0 0px;
    font-size: inherit;
    height: auto;
    text-align: left!important;
    width: 100%;
}

.is-table-bcentered {
    vertical-align: bottom !important;
}

.is-striped .button.is-outlined {
    background-color: var(--white);
}

button.navbar-item:hover, button.navbar-item:focus, button.navbar-item:active {
    background-color: #efefef;
    color: #000000;
}

tbody + tbody > tr:first-child > td {
    border-top-width: 2px;
}

main {
    padding: 0 1em;
}

.has-background-transparent {
    background-color: transparent !important;
}

.table.is-unbordered th,
.table.is-unbordered td {
    border-width: 0;
}

.table tr.subheading td,
.table tr.subheading th {
    border-bottom-width: 2px;
}

.form-errors .help,
.form-errors .tag {
    font-size: 1rem;
}

.form-errors .help.is-danger { color: white; }

/* Helper class and animation for notifications to appear and disappear. */
@keyframes notification-animation {
    0% { margin-left: 22em; }
    10% { margin-left: 0; }
    90% { margin-left: 0; }
    100% { margin-left: 22em; }
}
.from-right {
    animation: 3s linear 0s 1 normal none notification-animation;
    margin-left: 22em;
    position: relative;
    width: 20em;
}

#notification-holder {
    display: flex;
    flex-direction: column;
    justify-content: flex-end;
    position: fixed;
    bottom: 2em;
    right: 2em;
    width: 20em;
    z-index: 50;
}

/* Some fanciness for the dropdown arrows of navbar menus. */
.has-dropdown.is-active .navbar-link:not(.is-arrowless)::after,
.has-dropdown:hover .navbar-link:not(.is-arrowless)::after {
    transition: opacity .25s, transform .25s;
}

.has-dropdown.is-active .navbar-link:not(.is-arrowless)::after,
.has-dropdown:hover .navbar-link:not(.is-arrowless)::after {
    opacity: 0;
    transform: rotate(135deg);
}

.cohort-workflow-expandable {
    margin-top: 0 !important;
    margin-bottom: 1em !important;
    margin-left: 1em !important;
}

.cohort-workflow-expandable ul {
    margin-top: 0 !important;
}

.cohort-summary {
    margin-bottom: 4px !important;
}

.assessment-template-list,
.has-no-list {
    list-style: none !important;
}

.assessment-template-list-item.is-active {
    background-color: var(--primary-light);
}

.assessment-template-list-item + .assessment-template-list-item {
    border-top: 1px solid var(--border-color);
}

.is-narrow-column {
    width: 1rem;
}

.block-tag {
    display: inline-block;
    border-radius: 4px;
    margin: 0.25rem;
    padding: 0.5rem 1rem;
}

.block-tag.is-fullwidth {
    width: 100%;
}

.block-tag.is-success {
    color: var(--white);
    background-color: var(--success);
}

.block-tag.is-warning {
    color: var(--white);
    background-color: var(--warning);
}

.block-tag.is-danger {
    color: var(--white);
    background-color: var(--danger);
}

.past-cohort-record {
    border-top: 1px solid var(--border-color);
}

.is-bordered {
    border: 1px solid var(--border-color);
}

.is-borderless {
    border: 0 !important;
}

.bl-1 {
    border-left: 1px solid var(--border-color) !important;
}

.bb-1 {
    border-bottom: 1px solid var(--border-color) !important;
}

.br-1 {
    border-right: 1px solid var(--border-color) !important;
}

.bt-1 {
    border-top: 1px solid var(--border-color) !important;
}

#instructor-info table.is-bordered.is-tab-content-bordered,
#instructor-info table.is-bordered .is-tab-content-bordered,
#student-info .is-tab-content-bordered {
    border: 1px solid var(--border-color);
    border-top: 0 solid transparent;
}

.is-grid {
    display: grid;
}

.past-cohort-info {
    grid-template-columns: auto auto 1fr;
    --grid-padding: 0.75rem;
}

.past-cohort-info > * {
    border-top: 1px solid var(--border-color);
}

.past-cohort-info > :nth-child(3n + 1) {
    padding: var(--grid-padding);
    padding-left: 0;
}

.past-cohort-info > :nth-child(3n + 2) {
    padding: var(--grid-padding);
}

.past-cohort-info > :nth-child(3n) {
    padding: var(--grid-padding);
    padding-right: 0;
}

.three-columns {
    columns: 3;
}

.attendance-calendar {
    display: inline-grid;
    grid-template-columns: repeat(7, auto);
    grid-auto-rows: 1fr;
}

.attendance-calendar-day-heading {
    align-self: end;
}

.attendance-calendar-day {
    background-color: var(--white);
    padding: 0.5rem;
    border: 1px solid var(--border-color);
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    justify-items: center;
}

.attendance-calendar-date {
    grid-column: 1 / span 3;
    padding-bottom: .25rem;
}

.can-reveal {
    cursor: pointer;
}

.is-shadowed {
    box-shadow: var(--primary-shadow), var(--secondary-shadow);
}

.is-not-fullwidth {
    width: auto;
}

label.is-required::after {
    content: " (required)"
}

details summary {
    cursor: pointer;
    margin-bottom: 0.3em;
    user-select: none;
}

details summary > * {
    display: inline;
    position: relative;
    top: 0.15em;
}

details summary > :first-child {
    margin-left: 0.25rem;
}

details[open] summary {
    margin-bottom: 1rem;
}

details.info {
    border-radius: 3px;
    position: relative;
    transition: 0.15s background linear;
}

details.info summary {
    background: url("../img/info.svg") 0 5px no-repeat;
    list-style: none;
    padding-left: 28px;
    cursor: pointer;
    color: var(--link);
    font-weight: bold;
}

/* .instructor-dashboard-grid {
    grid-template-columns: repeat(1, 1fr);
    grid-auto-rows: 1fr;
} */

.instructor-dashboard-grid .card {
    margin: 1em;
}

.is-status.is-danger-light {
    background-color: var(--danger-light);
}

.is-status.is-warning-light {
    background-color: var(--warning-light);
}

input.is-success {
    background-color: var(--primary-light);
}

input.is-warning {
    background-color: var(--warning-light);
}

input.is-unbordered {
    border-width: 0 !important;
}
tr.is-homework td{
    background-color: lightgreen;
}
tr.is-lab td{
    background-color: lightblue;
}
tr.is-lecture td{
    background-color: lightsalmon;
}
tr.is-recap td{
    background-color: lightyellow;
}

.textarea[markdown] {
    white-space: nowrap;
    resize: none;
    font-family: monospace;
    overflow-wrap: normal;
    overflow-x: scroll;
}

.card-footer + .card-content {
    border-top: 1px solid var(--border-color-light);
}

.attendance_spinner {
  border: 16px solid #f3f3f3;
  border-top: 16px solid #3498db;
  border-radius: 50%;
  width: 130px;
  height: 130px;
  animation: spin 1s linear infinite;
  margin-left: 40%;
}

.attendance_spinner.is-small {
    width: 16px;
    height: 16px;
    border: 4px solid #f3f3f3;
    border-top: 4px solid #3498db;
}

@keyframes spin {
  0%  { transform: rotate(0deg); }
  100% { transform: rotate(360deg); }
}

td.is-vcentered {
    vertical-align: middle;
}

.content {
    margin-top: 12px;
}

.content table.has-row-spans tbody tr:last-child td {
    border-bottom-width: 1px;
}

table.table tbody tr.is-striped {
    background-color: var(--table-stripe);
}

table.table thead tr th.is-super-heading {
    border-bottom-width: 1px;
}

.attendance-place {
    padding-left: 1.75rem;
}

.time-column {
    width: 130px;
}

.tabs li.is-active {
    background-color: var(--active-tab-color);
}

.schedule-table tbody tr.is-active,
.schedule-table.is-hoverable tbody tr.is-active:hover,
#gradebook tr.is-active {
    background-color: hsl(207, 61%, 53%) !important;
    color: white !important;
}
.schedule-table tbody tr.is-inactive,
#gradebook tr.is-inactive {
    color: hsl(0, 0%, 71%) !important;
}
.schedule-table tbody tr.is-inactive select {
    color: hsl(0, 0%, 71%) !important;
}

.schedule-date-column {
    max-width: 4.5em;
}

html.has-background-dark .schedule-table tbody tr.is-inactive {
    color: hsl(0, 0%, 40%) !important;
}
html.has-background-dark .schedule-table tbody tr.is-inactive select {
    color: hsl(0, 0%, 40%) !important;
}

.navbar-brand .navbar-dropdown {
    background-color: var(--white);
    border-bottom-left-radius: 6px;
    border-bottom-right-radius: 6px;
    border-top: 2px solid var(--border-color);
    box-shadow: 0 8px 8px rgb(10 10 10 / 10%);
    display: none;
    font-size: 0.875rem;
    left: 0;
    min-width: 100%;
    position: absolute;
    top: 100%;
    z-index: 20;
}

.navbar-brand .navbar-item.is-active .navbar-dropdown,
.navbar-brand .navbar-item.is-hoverable:focus .navbar-dropdown,
.navbar-brand .navbar-item.is-hoverable:focus-within .navbar-dropdown,
.navbar-brand .navbar-item.is-hoverable:hover .navbar-dropdown {
    display: block;
}

.width-200px {
    width: 200px !important;
}

.width-300px {
    width: 300px !important;
}

.width-150px {
    width: 150px !important;
    max-width: 150px !important;
}

.width-8em {
    width: 8em !important;
    max-width: 8em !important;
}

.is-overflow-hidden {
    overflow: hidden !important;
}

.has-white-space-nowrap {
    white-space: nowrap !important;
}

.has-text-overflow-ellipsis {
    text-overflow: ellipsis !important;
}

.input-success {
    animation-duration: 1s;
    animation-name: flash-success;
}

@keyframes flash-success {
    from {
        border-color: green;
        background-color: forestgreen;
        color: white
    }
    to {
        border-color: #aaa;
        border-width: 1px;
        background-color: default;
        color: black
    }
}

html.has-background-dark .box .box {
    background-color: var(--grey-light);
}

html.has-background-dark .table.is-striped a {
    color: var(--link-light);
}

html.has-background-dark .table.is-striped a.button.is-outlined {
    color: var(--grey-darker);
}

.has-min-width-150 {
    min-width: 150px !important;
}

.assignment-grid {
    display: grid;
    gap: 1em;
    grid-template-columns: repeat(4, 1fr);
}

.assignment-grid-card,
.rooms-dashboard-card {
    border: 1px solid var(--border-color);
    border-radius: 4px;
}

.rooms-dashboard-card {
    flex: 0 0 200px;
}

.wide-10em {
    width: 10em;
}

.wide-0em {
    width: 0em;
}

#roster .headshot {
    width: 48px;
    height: 48px;
    background-size: cover;
    background-position: center center;
}

#roster .headshot-popup {
    position: relative;
    display: none;
}

#roster .headshot-popup .box {
    position: absolute;
    top: -48px;
    left: 60px;
}

#roster .headshot-link:hover + .headshot-popup {
    display: block;
}

#roster .headshot-popup img {
    max-width: 640px;
}

#roster .headshot-cell {
    width: 64px;
}

#main-nav .headshot {
    width: 32px;
    height: 32px;
    background-size: cover;
    background-position: center center;
    border-radius: 16px;
}

#multi-program-layout {
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    gap: 1em;
}

#multi-program-layout .card {
    display: flex;
    flex-direction: column;
}

#multi-program-layout .card .card-content {
    flex-grow: 1;
}

@media screen and (max-width: 1216px) {
    #multi-program-layout {
        grid-template-columns: repeat(2, 1fr);
    }
}

@media screen and (max-width: 768px) {
    #multi-program-layout {
        grid-template-columns: 1fr;
    }
}

.grade-table-container {
    height: calc(100vh - 15em);
    width: calc(100vw - 5.5rem);
    overflow: auto;
}

.grade-table-container .table {
    border-collapse: separate !important;
}

.grade-table-container .table td,
.grade-table-container .table th {
    border-left: 1px solid var(--border-color);
    border-top: 1px solid var(--border-color);
    border-right-color: transparent;
    border-bottom-color: transparent;
}

.grade-table-container .table th:first-child {
    background-color: white;
    border-right-color: var(--border-color);
    position: -webkit-sticky;
    position: sticky;
    left: 0;
    z-index: 18;
}

.grade-table-container .table thead {
    background-color: white;
    position: -webkit-sticky;
    position: sticky;
    top: 0;
    z-index: 19;
}

.grade-table-container .table thead tr:last-child td,
.grade-table-container .table thead tr:last-child th {
    border-bottom-color: var(--border-color);
}

.t-rex {
    width: 15vw;
    max-width: 300px;
    height: auto;
}

.error-box {
    margin: auto;
    max-width: 640px;
    min-width: 300px;
    width: 90vw;
}

.has-hackreactor-dark-background {
    background-color: var(--hackreactor-dark-blue) !important;
}

.card.has-hackreactor-dark-background * {
    color: var(--white);
}

.has-moodle-light-background {
    background-color: var(--white-ter) !important;
    border: 1px solid var(--border-color) !important;
}

.card.has-moodle-light-background * {
    color: var(--black);
}

ul.tabular {
    list-style: none;
    margin: 0;
    padding: 0;
}

ul.tabular > li {
    display: grid;
    grid-template-columns: 1fr 1fr 3fr;
    margin-bottom: 0.75em;
    padding-bottom: 0.75em;
    border-bottom: 1px solid var(--border-color);
}